/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 16/11/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;


import org.hibernate.annotations.ForeignKey;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import javax.persistence.*;
import javax.validation.constraints.*;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.Departemen;
import com.portofolio.entity.Profile;
import com.portofolio.entity.vo.ShiftKerjaId;

import org.hibernate.annotations.Type;



@Entity
@Table(name = "ShiftKerja_M",indexes = {@Index(name = "ShiftKerja_M_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class ShiftKerja {
    
    @EmbeddedId
    private ShiftKerjaId id ;
    
    private static final String cDefNamaShift = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "NamaShift", columnDefinition = cDefNamaShift)
    @NotNull(message = "shiftkerja.namashift.notnull")
    private String namaShift;
    
    private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "ReportDisplay", columnDefinition = cDefReportDisplay)
    @NotNull(message = "shiftkerja.reportdisplay.notnull")
    private String reportDisplay;
    
    private static final String cDefJamMasuk = VARCHAR + AWAL_KURUNG + 5 + AKHIR_KURUNG ;
    @Column(name = "JamMasuk", columnDefinition = cDefJamMasuk)
    @NotNull(message = "shiftkerja.jammasuk.notnull")
    private String jamMasuk;
    
    private static final String cDefJamPulang = VARCHAR + AWAL_KURUNG + 5 + AKHIR_KURUNG ;
    @Column(name = "JamPulang", columnDefinition = cDefJamPulang)
    @NotNull(message = "shiftkerja.jampulang.notnull")
    private String jamPulang;
    
    private static final String cDefQtyJamKerjaEfektif = FLOAT ;
    @Column(name = "QtyJamKerjaEfektif", columnDefinition = cDefQtyJamKerjaEfektif)
    private Float qtyJamKerjaEfektif;
    
    private static final String cDefJamBreakAwal = VARCHAR + AWAL_KURUNG + 5 + AKHIR_KURUNG ;
    @Column(name = "JamBreakAwal", columnDefinition = cDefJamBreakAwal)
    private String jamBreakAwal;
    
    private static final String cDefJamBreakAkhir = VARCHAR + AWAL_KURUNG + 5 + AKHIR_KURUNG ;
    @Column(name = "JamBreakAkhir", columnDefinition = cDefJamBreakAkhir)
    private String jamBreakAkhir;
    
    private static final String cDefQtyJamBreakEfektif = FLOAT ;
    @Column(name = "QtyJamBreakEfektif", columnDefinition = cDefQtyJamBreakEfektif)
    private Float qtyJamBreakEfektif;
    
    private static final String cDefFactorRate = FLOAT ;
    @Column(name = "FactorRate", columnDefinition = cDefFactorRate)
    @NotNull(message = "shiftkerja.factorrate.notnull")
    private Float factorRate;
    
    private static final String cDefOperatorFactorRate = CHAR + AWAL_KURUNG + 1 + AKHIR_KURUNG ;
    @Column(name = "OperatorFactorRate", columnDefinition = cDefOperatorFactorRate)
    @NotNull(message = "shiftkerja.operatorfactorrate.notnull")
    private String operatorFactorRate;
    
    private static final String cDefKodeExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KodeExternal", columnDefinition = cDefKodeExternal)
    private String kodeExternal;
    
    private static final String cDefNamaExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "NamaExternal", columnDefinition = cDefNamaExternal)
    private String namaExternal;
    
    private static final String cDefKdDepartemen = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KdDepartemen", columnDefinition = cDefKdDepartemen)
    @NotNull(message = "shiftkerja.kddepartemen.notnull")
    private String kdDepartemen;
    
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "shiftkerja.statusenabled.notnull")
    @Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "shiftkerja.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "shiftkerja.version.notnull")
    private Integer version;
    

    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Profile profile;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdDepartemen", referencedColumnName="KdDepartemen",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Departemen departemen;
    
 
}
